Index: modules/AngularSmearing.cc
===================================================================
--- modules/AngularSmearing.cc	(revision a5af1df1cf2ca5a488fc610ab546c762b7cdb5f2)
+++ modules/AngularSmearing.cc	(revision d612deca94f89952da103f30d46e21c02039b8bc)
@@ -98,20 +98,19 @@
 {
   Candidate *candidate, *mother;
-  Double_t pt, eta, phi, e;
+  Double_t pt, eta, phi, e, m;
 
   fItInputArray->Reset();
   while((candidate = static_cast<Candidate *>(fItInputArray->Next())))
   {
-    const TLorentzVector &candidatePosition = candidate->Position;
     const TLorentzVector &candidateMomentum = candidate->Momentum;
-    eta = candidatePosition.Eta();
-    phi = candidatePosition.Phi();
+    eta = candidateMomentum.Eta();
+    phi = candidateMomentum.Phi();
     pt = candidateMomentum.Pt();
     e = candidateMomentum.E();
+    m = candidateMomentum.M();
 
     // apply smearing formula for eta,phi
-
-    eta = gRandom->Gaus(eta, fFormulaEta->Eval(pt, eta, phi, e));
-    phi = gRandom->Gaus(phi, fFormulaPhi->Eval(pt, eta, phi, e));
+    eta = gRandom->Gaus(eta, fFormulaEta->Eval(pt, eta, phi, e, candidate));
+    phi = gRandom->Gaus(phi, fFormulaPhi->Eval(pt, eta, phi, e, candidate));
 
     if(pt <= 0.0) continue;
@@ -119,7 +118,5 @@
     mother = candidate;
     candidate = static_cast<Candidate *>(candidate->Clone());
-    eta = candidateMomentum.Eta();
-    phi = candidateMomentum.Phi();
-    candidate->Momentum.SetPtEtaPhiE(pt, eta, phi, pt * TMath::CosH(eta));
+    candidate->Momentum.SetPtEtaPhiM(pt, eta, phi, m);
     candidate->AddCandidate(mother);
 
Index: modules/Calorimeter.cc
===================================================================
--- modules/Calorimeter.cc	(revision a5af1df1cf2ca5a488fc610ab546c762b7cdb5f2)
+++ modules/Calorimeter.cc	(revision d612deca94f89952da103f30d46e21c02039b8bc)
@@ -231,8 +231,13 @@
   fItParticleInputArray->Reset();
   number = -1;
+  fTowerRmax=0.;
   while((particle = static_cast<Candidate *>(fItParticleInputArray->Next())))
   {
     const TLorentzVector &particlePosition = particle->Position;
     ++number;
+
+    // compute maximum radius (needed in FinalizeTower to assess whether barrel or endcap tower)
+    if (particlePosition.Perp() > fTowerRmax)
+      fTowerRmax=particlePosition.Perp();
 
     pdgCode = TMath::Abs(particle->PID);
@@ -450,4 +455,5 @@
 
     fTower->AddCandidate(particle);
+    fTower->Position = position;
   }
 
@@ -461,5 +467,5 @@
 {
   Candidate *track, *tower, *mother;
-  Double_t energy, pt, eta, phi;
+  Double_t energy, pt, eta, phi, r;
   Double_t ecalEnergy, hcalEnergy;
   Double_t ecalNeutralEnergy, hcalNeutralEnergy;
@@ -511,5 +517,5 @@
   for(size_t i = 0; i < fTower->ECalEnergyTimePairs.size(); ++i)
   {
-    weight = TMath::Sqrt(fTower->ECalEnergyTimePairs[i].first);
+    weight = TMath::Power((fTower->ECalEnergyTimePairs[i].first),2);
     sumWeightedTime += weight * fTower->ECalEnergyTimePairs[i].second;
     sumWeight += weight;
@@ -517,11 +523,17 @@
   }
 
+  // check whether barrel or endcap tower
+  if (fTower->Position.Perp() < fTowerRmax && TMath::Abs(eta) > 0.)
+    r = fTower->Position.Z()/TMath::SinH(eta);
+  else
+    r = fTower->Position.Pt();
+
   if(sumWeight > 0.0)
   {
-    fTower->Position.SetPtEtaPhiE(1.0, eta, phi, sumWeightedTime / sumWeight);
+    fTower->Position.SetPtEtaPhiE(r, eta, phi, sumWeightedTime / sumWeight);
   }
   else
   {
-    fTower->Position.SetPtEtaPhiE(1.0, eta, phi, 999999.9);
+    fTower->Position.SetPtEtaPhiE(r, eta, phi, 999999.9);
   }
 
@@ -559,5 +571,5 @@
   if(ecalNeutralEnergy > fECalEnergyMin && ecalNeutralSigma > fECalEnergySignificanceMin)
   {
-    // create new photon tower
+    // create new photon tower assuming null mass
     tower = static_cast<Candidate *>(fTower->Clone());
     pt = ecalNeutralEnergy / TMath::CosH(eta);
@@ -646,6 +658,6 @@
       track = static_cast<Candidate *>(track->Clone());
       track->AddCandidate(mother);
-
       track->Momentum *= rescaleFactor;
+      track->Momentum.SetPtEtaPhiM(track->Momentum.Pt()*rescaleFactor, track->Momentum.Eta(), track->Momentum.Phi(), track->Momentum.M());
 
       fEFlowTrackOutputArray->Add(track);
Index: modules/Calorimeter.h
===================================================================
--- modules/Calorimeter.h	(revision a5af1df1cf2ca5a488fc610ab546c762b7cdb5f2)
+++ modules/Calorimeter.h	(revision d612deca94f89952da103f30d46e21c02039b8bc)
@@ -60,4 +60,5 @@
   Double_t fTimingEnergyMin;
   Bool_t fElectronsFromTrack;
+  Double_t fTowerRmax;
 
   Int_t fTowerTrackHits, fTowerPhotonHits;
Index: modules/ClusterCounting.cc
===================================================================
--- modules/ClusterCounting.cc	(revision d612deca94f89952da103f30d46e21c02039b8bc)
+++ modules/ClusterCounting.cc	(revision d612deca94f89952da103f30d46e21c02039b8bc)
@@ -0,0 +1,139 @@
+   /*
+ *  Delphes: a framework for fast simulation of a generic collider experiment
+ *  Copyright (C) 2020  Universite catholique de Louvain (UCLouvain), Belgium
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/** \class ClusterCounting
+ *
+ *  Counts ionisation clusters of energy loss in drift chambers
+ *
+ *  \authors F. Bedeschi - INFN Pisa
+*            P. Demin - UCLouvain, Louvain-la-Neuve
+ *           M. Selvaggi - CERN
+ *
+ *
+ */
+
+#include "modules/ClusterCounting.h"
+#include "classes/DelphesClasses.h"
+#include "TrackCovariance/TrkUtil.h"
+
+#include "TLorentzVector.h"
+#include "TVectorD.h"
+#include "TMath.h"
+#include "TObjArray.h"
+
+#include <iostream>
+#include <sstream>
+
+using namespace std;
+
+//------------------------------------------------------------------------------
+
+ClusterCounting::ClusterCounting() :
+  fTrackUtil(0)
+{
+  fTrackUtil = new TrkUtil();
+}
+
+//------------------------------------------------------------------------------
+
+ClusterCounting::~ClusterCounting()
+{
+  if(fTrackUtil) delete fTrackUtil;
+}
+
+//------------------------------------------------------------------------------
+
+void ClusterCounting::Init()
+{
+
+  // geometric acceptance
+  fRmin  = GetDouble("Rmin", 0.);
+  fRmax  = GetDouble("Rmax", 0.);
+  fZmin  = GetDouble("Zmin", 0.);
+  fZmax  = GetDouble("Zmax", 0.);
+
+  // magnetic field
+  fBz    = GetDouble("Bz", 0.);
+
+  // gas mix option: 0
+  // 0:  Helium 90 - Isobutane 10
+  // 1:  Helium 100
+  // 2:  Argon 50 - Ethane 50
+  // 3:  Argon 100
+  fGasOption = GetInt("GasOption", 0);
+
+  // initialize drift chamber geometry and gas mix
+  fTrackUtil->SetBfield(fBz);
+  fTrackUtil->SetDchBoundaries(fRmin, fRmax, fZmin, fZmax);
+  fTrackUtil->SetGasMix(fGasOption);
+
+  // import input array
+  fInputArray = ImportArray(GetString("InputArray", "TrackMerger/tracks"));
+  fItInputArray = fInputArray->MakeIterator();
+
+  // create output array
+  fOutputArray = ExportArray(GetString("OutputArray", "tracks"));
+}
+
+//------------------------------------------------------------------------------
+
+void ClusterCounting::Finish()
+{
+  if(fItInputArray) delete fItInputArray;
+}
+
+//------------------------------------------------------------------------------
+
+void ClusterCounting::Process()
+{
+  Candidate *candidate, *mother, *particle;
+  Double_t mass, trackLength, Ncl;
+
+  fItInputArray->Reset();
+  while((candidate = static_cast<Candidate *>(fItInputArray->Next())))
+  {
+
+    // converting to meters
+    particle = static_cast<Candidate *>(candidate->GetCandidates()->At(0));
+
+    // converting to meters
+    const TLorentzVector &candidatePosition = particle->Position*1e-03;
+    const TLorentzVector &candidateMomentum = particle->Momentum;
+
+		TVectorD Par = TrkUtil::XPtoPar(candidatePosition.Vect(), candidateMomentum.Vect(), candidate->Charge, fBz);
+    mass = candidateMomentum.M();
+
+    trackLength = fTrackUtil->TrkLen(Par);
+
+    mother    = candidate;
+    candidate = static_cast<Candidate*>(candidate->Clone());
+
+    Ncl = 0.;
+    if (fTrackUtil->IonClusters(Ncl, mass, Par))
+    {
+      candidate->Nclusters = Ncl;
+      candidate->dNdx = (trackLength > 0.) ? Ncl/trackLength : -1;
+    }
+
+    candidate->AddCandidate(mother);
+
+    fOutputArray->Add(candidate);
+  }
+}
+
+//------------------------------------------------------------------------------
Index: modules/ClusterCounting.h
===================================================================
--- modules/ClusterCounting.h	(revision d612deca94f89952da103f30d46e21c02039b8bc)
+++ modules/ClusterCounting.h	(revision d612deca94f89952da103f30d46e21c02039b8bc)
@@ -0,0 +1,69 @@
+/*
+ *  Delphes: a framework for fast simulation of a generic collider experiment
+ *  Copyright (C) 2020  Universite catholique de Louvain (UCLouvain), Belgium
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef ClusterCounting_h
+#define ClusterCounting_h
+
+/** \class ClusterCounting
+ *
+ *  Counts ionisation clusters of energy loss in drift chambers
+ *
+ *  \authors F. Bedeschi - INFN
+ *           M. Selvaggi - CERN
+ *
+ */
+
+#include "classes/DelphesModule.h"
+
+class TIterator;
+class TObjArray;
+
+class TrkUtil;
+
+class ClusterCounting: public DelphesModule
+{
+public:
+  ClusterCounting();
+  ~ClusterCounting();
+
+  void Init();
+  void Process();
+  void Finish();
+
+private:
+
+  Double_t fRmin;
+	Double_t fRmax;
+	Double_t fZmin;
+	Double_t fZmax;
+  Double_t fBz;
+
+  Int_t fGasOption;
+
+  TrkUtil *fTrackUtil;
+
+  TIterator *fItInputArray; //!
+
+  const TObjArray *fInputArray; //!
+
+  TObjArray *fOutputArray; //!
+
+  ClassDef(ClusterCounting, 1)
+};
+
+#endif
Index: modules/DecayFilter.cc
===================================================================
--- modules/DecayFilter.cc	(revision d612deca94f89952da103f30d46e21c02039b8bc)
+++ modules/DecayFilter.cc	(revision d612deca94f89952da103f30d46e21c02039b8bc)
@@ -0,0 +1,136 @@
+/*
+ *  Delphes: a framework for fast simulation of a generic collider experiment
+ *  Copyright (C) 2012-2014  Universite catholique de Louvain (UCL), Belgium
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/** \class DecayFilter
+ *
+ *  This module randomly generates decays along the particle trajectory length 
+ *  according to actual particle decay length, taking into account for the boost
+ *  and using ROOT TDatabasePDG as a source for the particle lifetime.
+ *
+ *  This module is to to be used after a PropagateParticle step or a similar module
+ *  that calculates and store a trajectory length.
+ *
+ *  Particles that decay are not added to the OutputArray.
+ *
+ *  \author R. Preghenella - INFN, Bologna
+ *
+ */
+
+#include "modules/DecayFilter.h"
+
+#include "classes/DelphesClasses.h"
+#include "classes/DelphesFactory.h"
+#include "classes/DelphesFormula.h"
+
+#include "ExRootAnalysis/ExRootClassifier.h"
+#include "ExRootAnalysis/ExRootFilter.h"
+#include "ExRootAnalysis/ExRootResult.h"
+
+#include "TDatabasePDG.h"
+#include "TParticlePDG.h"
+#include "TFormula.h"
+#include "TLorentzVector.h"
+#include "TMath.h"
+#include "TObjArray.h"
+#include "TRandom3.h"
+#include "TString.h"
+
+#include <algorithm>
+#include <iostream>
+#include <sstream>
+#include <stdexcept>
+
+using namespace std;
+
+//------------------------------------------------------------------------------
+
+DecayFilter::DecayFilter() :
+  fItInputArray(0)
+{}
+
+//------------------------------------------------------------------------------
+
+DecayFilter::~DecayFilter()
+{}
+
+//------------------------------------------------------------------------------
+
+void DecayFilter::Init()
+{
+
+  // import input array(s)
+
+  fInputArray = ImportArray(GetString("InputArray", "FastJetFinder/jets"));
+  fItInputArray = fInputArray->MakeIterator();
+
+  // create output array(s)
+
+  fOutputArray = ExportArray(GetString("OutputArray", "tracks"));
+}
+
+//------------------------------------------------------------------------------
+
+void DecayFilter::Finish()
+{
+  if(fItInputArray) delete fItInputArray;
+}
+
+//------------------------------------------------------------------------------
+
+void DecayFilter::Process()
+{
+  Candidate *candidate;
+  TDatabasePDG *pdgdb = TDatabasePDG::Instance();
+  const Double_t c = TMath::C(); // [m/s]
+  Double_t m, t, p, bgct, L, l;
+  Bool_t hasDecayed = kFALSE;
+  
+  // loop over all input candidates
+  fItInputArray->Reset();
+  while((candidate = static_cast<Candidate *>(fItInputArray->Next())))
+  {
+    // get particle information from PDG
+    TParticlePDG *pdg = pdgdb->GetParticle(candidate->PID);
+    if (!pdg) { // don't know this particle
+      fOutputArray->Add(candidate);
+      continue;
+    }    
+    m = pdg->Mass();
+    t = pdg->Lifetime(); // [s]
+    if (t == 0.) { // does not decay
+      fOutputArray->Add(candidate);
+      continue;
+    }
+
+    // compute boosted decay length (beta gamma c tau)
+    p = candidate->P;
+    bgct = p / m * c * t; // [m]
+
+    // get full trajectory length and generate random decay length
+    L = candidate->L * 1.0E-3; // [m]
+    l = gRandom->Exp(bgct);
+
+    // if random decay happens before end of trajectory, reject track
+    if (l < L) continue;
+
+    // else particle did not decay within the trajectory
+    fOutputArray->Add(candidate);
+  }
+}
+
+//------------------------------------------------------------------------------
Index: modules/DecayFilter.h
===================================================================
--- modules/DecayFilter.h	(revision d612deca94f89952da103f30d46e21c02039b8bc)
+++ modules/DecayFilter.h	(revision d612deca94f89952da103f30d46e21c02039b8bc)
@@ -0,0 +1,64 @@
+/*
+ *  Delphes: a framework for fast simulation of a generic collider experiment
+ *  Copyright (C) 2012-2014  Universite catholique de Louvain (UCL), Belgium
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef DecayFilter_h
+#define DecayFilter_h
+
+/** \class DecayFilter
+ *
+ *  This module randomly generates decays along the particle trajectory length 
+ *  according to actual particle decay length, taking into account for the boost
+ *  and using ROOT TDatabasePDG as a source for the particle lifetime.
+ *
+ *  This module is to to be used after a PropagateParticle step or a similar module
+ *  that calculates and store a trajectory length.
+ *
+ *  Particles that decay are not added to the OutputArray.
+ *
+ *  \author R. Preghenella - INFN, Bologna
+ *
+ */
+
+#include "classes/DelphesModule.h"
+
+#include <deque>
+
+class TObjArray;
+
+class DecayFilter: public DelphesModule
+{
+public:
+  DecayFilter();
+  ~DecayFilter();
+
+  void Init();
+  void Process();
+  void Finish();
+
+private:
+
+  TIterator *fItInputArray; //!
+
+  const TObjArray *fInputArray; //!
+
+  TObjArray *fOutputArray; //!
+
+  ClassDef(DecayFilter, 1)
+};
+
+#endif
Index: modules/Delphes.cc
===================================================================
--- modules/Delphes.cc	(revision a5af1df1cf2ca5a488fc610ab546c762b7cdb5f2)
+++ modules/Delphes.cc	(revision d612deca94f89952da103f30d46e21c02039b8bc)
@@ -61,6 +61,9 @@
   fFactory(0)
 {
-  TFolder *folder = new TFolder(name, "");
+  TFolder *folder;
+
   fFactory = new DelphesFactory("ObjectFactory");
+
+  folder = new TFolder(name, "");
 
   SetName(name);
@@ -80,4 +83,5 @@
   if(folder)
   {
+    gROOT->GetListOfBrowsables()->Remove(folder);
     folder->Clear();
     delete folder;
Index: modules/DenseTrackFilter.cc
===================================================================
--- modules/DenseTrackFilter.cc	(revision a5af1df1cf2ca5a488fc610ab546c762b7cdb5f2)
+++ modules/DenseTrackFilter.cc	(revision d612deca94f89952da103f30d46e21c02039b8bc)
@@ -237,5 +237,5 @@
 
   Candidate *candidate, *track;
-  Double_t pt, eta, phi;
+  Double_t pt, eta, phi, m;
   Int_t numberOfCandidates;
 
@@ -251,7 +251,9 @@
   eta = candidate->Momentum.Eta();
   phi = candidate->Momentum.Phi();
+  m = candidate->Momentum.M();
+
   eta = gRandom->Gaus(eta, fEtaPhiRes);
   phi = gRandom->Gaus(phi, fEtaPhiRes);
-  candidate->Momentum.SetPtEtaPhiE(pt, eta, phi, pt * TMath::CosH(eta));
+  candidate->Momentum.SetPtEtaPhiM(pt, eta, phi, m);
   candidate->AddCandidate(track);
 
